//
//	VidyoRemoteCamera_Objc.h
//	VidyoClient
//
//	This file is auto generated, do not edit this file
//	Copyright (c) 2016 Vidyo, Inc. All rights reserved.
//

#import "VidyoCameraControlCapabilities_Objc.h"
#import "VidyoLocalRenderer_Objc.h"
#import "VidyoParticipant_Objc.h"
#import "VidyoVideoFrame_Objc.h"
typedef NS_ENUM(NSInteger, VCRemoteCameraMode){
	VCRemoteCameraModeDynamic,
	VCRemoteCameraModeStatic
};
typedef NS_ENUM(NSInteger, VCRemoteCameraPosition){
	VCRemoteCameraPositionUnknown,
	VCRemoteCameraPositionFront,
	VCRemoteCameraPositionBack
};
@protocol VCRemoteCameraIRegisterFrameEventListener

	-(void) onRemoteCameraFrame:(VCParticipant*)participant VideoFrame:(VCVideoFrame*)videoFrame;
@end
@protocol VCRemoteCameraIRegisterFrameSizeListener

	-(void) onFrameSizeUpdate:(size_t)width Height:(size_t)height;
@end
@interface VCRemoteCamera : NSObject
{
	void* objPtr;
	@public
	id<VCRemoteCameraIRegisterFrameEventListener> remoteCameraIRegisterFrameEventListener;
	id<VCRemoteCameraIRegisterFrameSizeListener> remoteCameraIRegisterFrameSizeListener;
}

	@property NSMutableString* id;
	@property NSMutableString* name;
	-(void) dealloc;
	-(long) addToLocalRenderer:(VCLocalRenderer*)localRenderer Mode:(VCRemoteCameraMode)mode;
	-(BOOL) controlPTZNudge:(int)pan Tilt:(int)tilt Zoom:(int)zoom;
	-(BOOL) controlPTZStart:(VCCameraControlDirection)direction Timeout:(long)timeout;
	-(BOOL) controlPTZStop;
	-(VCCameraControlCapabilities*) getControlCapabilities;
	-(NSString*) getId;
	-(long) getLocalRenderingStreamId:(int)index;
	-(NSString*) getName;
	-(VCRemoteCameraPosition) getPosition;
	-(BOOL) isControllable;
	-(BOOL) registerFrameEventListener:(id<VCRemoteCameraIRegisterFrameEventListener>)remoteCameraIRegisterFrameEventListener;
	-(BOOL) registerFrameSizeListener:(id<VCRemoteCameraIRegisterFrameSizeListener>)remoteCameraIRegisterFrameSizeListener;
	-(BOOL) removeFromLocalRenderer:(VCLocalRenderer*)localRenderer;
	-(BOOL) setPositionInLocalRenderer:(VCLocalRenderer*)localRenderer X:(int)x Y:(int)y Width:(unsigned int)width Height:(unsigned int)height FrameInterval:(long)frameInterval;
	-(BOOL) showCameraControl:(BOOL)show;
	-(BOOL) unregisterFrameEventListener;
	-(BOOL) unregisterFrameSizeListener;
	-(id) initWithObject:(void*)rPtr;
	-(void*)getObjectPtr;
@end
